#include <string>

template <typename DataType, typename LeftNode, typename RightNode>
struct fixed_tree{
	fixed_tree(const DataType& data, const LeftNode& left, const RightNode& right) : data_(data),left_(left),right_(right){}
	DataType data_;
	LeftNode left_;
	RightNode right_;
};

template <typename DataType, typename LeftNode>
struct fixed_tree<DataType,LeftNode,void>{
	fixed_tree(const DataType& data, const LeftNode& left) : data_(data),left_(left){}
	DataType data_;
	LeftNode left_;
};


template <typename DataType, typename RightNode>
struct fixed_tree<DataType,void,RightNode>{
	fixed_tree(const DataType& data, const RightNode& right) : data_(data),right_(right){}
	DataType data_;
	RightNode right_;
};

template <typename DataType>
struct fixed_tree<DataType,void,void>{
	fixed_tree(const DataType& data) : data_(data){}
	DataType data_;
};


namespace some_namespace{
	void some_function(int some_param0, int some_param1, fixed_tree<std::string, /* <br> */
															fixed_tree<int, /* <br> */
																fixed_tree<float, void, void >, /* <br> */
																fixed_tree<double, void, void >  /* <br> */
																>,
															fixed_tree<int,
																fixed_tree<double,void,
																	fixed_tree<char, 
																		fixed_tree<int, void,void>,
																		fixed_tree<int, void,void>
																	> >,
																void 
																>	
															> somewhat_lengthy_type
				){}
}															
